#include <linux/gamma/libgamma.h>
#include <stdio.h>
#include <stdlib.h>
#include "measure.h"

#define MASTER_NODE 0
#undef FREQUENCIES
#define PERF_SHORT
#define MAX_NODES 32


int main(int argc, char **argv) {

	double	record_mm[NPROVE];

	int	i, n_nodes, whoami;

	time_586
		t_send_s,
		t_rec;


	n_nodes = argc > 1 ? atoi(argv[1]) : MAX_NODES;

	gamma_init(n_nodes,argc,argv);

	whoami = gamma_my_node();

	if (gamma_sync() < 0) {
		printf("Node %d:  Could not syncronize!\n",whoami);
		fflush(stdout);
		gamma_exit();
		exit(-1);
	}

	for (i=0;i<NPROVE;i++) {
		gamma_sync();
		gamma_time(t_send_s);
		gamma_sync();
		gamma_time(t_rec);
		record_mm[i] = gamma_time_diff(t_rec, t_send_s);
	}
	gamma_exit();

	if (whoami == MASTER_NODE) {
#ifdef PERF_SHORT
		double mmm,Mmm,medmm,varmm;
		mean_variance(record_mm,&mmm,&Mmm,&medmm,&varmm);
		printf("%d %g\n",n_nodes,medmm);
#else
		double mmm,Mmm,medmm,varmm;
		mean_variance(record_mm,&mmm,&Mmm,&medmm,&varmm);
		printf("\n\n");
		printf("PERFORMANCE (microsec) (best < average < worst):\n\n");
	        printf("execution time %g < %g < %g node %d\n", mmm,medmm,Mmm,whoami);
		printf("\n");
	        printf("variance\t%g\n", varmm);
		printf("\n\n");
#ifdef FREQUENCIES
	        printf("FREQUENCIES (%):\n");
		frequencies(record_mm,mmm,Mmm);
#endif
		fflush(stdout);

#endif
	}

	return 0;

}
