#include <linux/linkage.h>      /*  "ALIGN", "ENTRY(name)"  */
#include <asm/asm-offsets.h>    /*  "pda_oldrsp", "pda_kernelstack"  */

/*
 * Register setup:
 * rax  system call number
 * rdi  arg0
 * rsi  arg1
 * rdx  arg2
 * rcx  arg3
 * r8   arg4
 */

ENTRY(gamma_system_call)
	swapgs
	movq %rsp,%gs:pda_oldrsp
	movq %gs:pda_kernelstack,%rsp
	cld
	subq $15*8+256,%rsp
	movq %rdi,14*8(%rsp)
	movq %rsi,13*8(%rsp)
	movq %rdx,12*8(%rsp)
	movq %rcx,11*8(%rsp)
/*	movq %rax,10*8(%rsp) */
	movq %r8,9*8(%rsp)
	movq %r9,8*8(%rsp)
	movq %r10,7*8(%rsp)
	movq %r11,6*8(%rsp)
	movq %rbx,5*8(%rsp)
	movq %rbp,4*8(%rsp)
	movq %r12,3*8(%rsp)
	movq %r13,2*8(%rsp)
	movq %r14,1*8(%rsp)
	movq %r15,(%rsp)
	sti
	call *gamma_sys_call_table(,%rax,8)
	cli
	movq 14*8(%rsp),%rdi
	movq 13*8(%rsp),%rsi
	movq 12*8(%rsp),%rdx
	movq 11*8(%rsp),%rcx
/*	movq 10*8(%rsp),%rax */
	movq 9*8(%rsp),%r8
	movq 8*8(%rsp),%r9
	movq 7*8(%rsp),%r10
	movq 6*8(%rsp),%r11
	movq 5*8(%rsp),%rbx
	movq 4*8(%rsp),%rbp
	movq 3*8(%rsp),%r12
	movq 2*8(%rsp),%r13
	movq 1*8(%rsp),%r14
	movq (%rsp),%r15
	addq $15*8+256,%rsp
	movq %gs:pda_oldrsp,%rsp
	swapgs
	iretq

	ALIGN
	.data
ENTRY(gamma_sys_call_table)
        .quad sys_gamma_init_part1	/*  0  */
        .quad sys_gamma_connect_port	/*  1  */
        .quad sys_gamma_send		/*  2  */
        .quad sys_gamma_exit		/*  3  */
        .quad sys_gamma_vm_create	/*  4  */
        .quad sys_gamma_vm_abort	/*  5  */
        .quad sys_gamma_register	/*  6  */
        .quad sys_gamma_getconfig	/*  7  */
        .quad sys_gamma_poll		/*  8  */
        .quad sys_gamma_timers		/*  9  */
        .quad sys_gamma_mlock		/* 10  */
        .quad sys_gamma_munlock		/* 11  */
        .quad sys_gamma_munlockall	/* 12  */
        .quad sys_gamma_init_part2	/* 13  */
        .quad sys_gamma_send_flowctl	/* 14  */
        .quad sys_gamma_send_2p_flowctl	/* 15  */
        .quad sys_gamma_send_2p		/* 16  */
        .quad sys_gamma_printk		/* 17  */
        .quad sys_gamma_poll_intranode	/* 18  */
        .quad sys_gamma_init_part3	/* 19  */
        .quad sys_gamma_suspend_irq	/* 20  */
        .quad sys_gamma_resume_irq	/* 21  */
        .quad sys_gamma_isend		/* 22  */
        .quad sys_gamma_isend_flowctl	/* 23  */
        .quad sys_gamma_isend_2p	/* 24  */
        .quad sys_gamma_isend_2p_flowctl/* 25  */
        .quad sys_gamma_wsend		/* 26  */
        .quad sys_gamma_tsend		/* 27  */
        .quad sys_gamma_vm_create_pid	/* 28  */
        .quad sys_gamma_vm_wish		/* 29  */
        .quad sys_gamma_vm_getinfo	/* 30  */
        .quad sys_gamma_register_nospawn/* 31  */
        .quad sys_gamma_setcredit	/* 32  */
        .quad sys_gamma_resetcredit	/* 33  */
        .quad sys_gamma_getcredit	/* 34  */
        .quad sys_gamma_setmaxpolls	/* 35  */
        .quad sys_gamma_resetmaxpolls	/* 36  */
        .quad sys_gamma_getmaxpolls	/* 37  */
        .quad sys_gamma_poll_nowait	/* 38  */
        .quad sys_gamma_post_recv	/* 39  */
        .quad sys_gamma_switch_to_buffer/* 40  */
        .quad sys_gamma_recvptr		/* 41  */
